/******************************************************************************
 * Copyright © 2013-2015 The Nxt Core Developers.                             *
 *                                                                            *
 * See the AUTHORS.txt, DEVELOPER-AGREEMENT.txt and LICENSE.txt files at      *
 * the top-level directory of this distribution for the individual copyright  *
 * holder information and the developer policies on copyright and licensing.  *
 *                                                                            *
 * Unless otherwise agreed in a custom licensing agreement, no part of the    *
 * Nxt software, including this file, may be copied, modified, propagated,    *
 * or distributed except according to the terms contained in the LICENSE.txt  *
 * file.                                                                      *
 *                                                                            *
 * Removal or modification of this copyright notice is prohibited.            *
 *                                                                            *
 ******************************************************************************/

/**
 * @depends {nrs.js}
 * @depends {nrs.modals.js}
 */
var NRS = (function(NRS, $) {
    var tokenModal = $("#token_modal");
    tokenModal.on("show.bs.modal", function() {
		$("#generate_token_output, #decode_token_output").html("").hide();

		$("#token_modal_generate_token").show();
		$("#token_modal_button").text($.t("generate")).data("form", "generate_token_form");
	});

	NRS.forms.generateToken = function() {
		var data = $.trim($("#generate_token_data").val());
		if (!data) {
			return {
				"error": $.t("data_required_field")
			};
		} else {
			return {};
		}
	};

	NRS.forms.generateTokenComplete = function(response) {
		$("#token_modal").find(".error_message").hide();

		if (response.token) {
			$("#generate_token_output").html($.t("generated_token_is") + "<br /><br /><textarea readonly style='width:100%' rows='3'>" + String(response.token).escapeHTML() + "</textarea>").show();
		} else {
			$.growl($.t("error_generate_token"), {
				"type": "danger"
			});
			$("#generate_token_modal").modal("hide");
		}
	};

	NRS.forms.generateTokenError = function() {
		$("#generate_token_output").hide();
	};

	NRS.forms.decodeTokenComplete = function(response) {
		$("#token_modal").find(".error_message").hide();

		if (response.valid) {
			$("#decode_token_output").html($.t("success_valid_token", {
				"account_link": NRS.getAccountLink(response, "account"),
				"timestamp": NRS.formatTimestamp(response.timestamp)
			})).addClass("callout-info").removeClass("callout-danger").show();
		} else {
			$("#decode_token_output").html($.t("error_invalid_token", {
				"account_link": NRS.getAccountLink(response, "account"),
				"timestamp": NRS.formatTimestamp(response.timestamp)
			})).addClass("callout-danger").removeClass("callout-info").show();
		}
	};

	NRS.forms.decodeTokenError = function() {
		$("#decode_token_output").hide();
	};

    tokenModal.find("ul.nav li").click(function(e) {
		e.preventDefault();

		var tab = $(this).data("tab");

		$(this).siblings().removeClass("active");
		$(this).addClass("active");

		$(".token_modal_content").hide();

		var content = $("#token_modal_" + tab);

		if (tab == "generate_token") {
			$("#token_modal_button").text($.t("generate")).data("form", "generate_token_form");
		} else {
			$("#token_modal_button").text($.t("validate")).data("form", "validate_token_form");
		}

		$("#token_modal").find(".error_message").hide();
		content.show();
	});

	tokenModal.on("hidden.bs.modal", function() {
		$(this).find(".token_modal_content").hide();
		$(this).find("ul.nav li.active").removeClass("active");
		$("#generate_token_nav").addClass("active");
	});

	return NRS;
}(NRS || {}, jQuery));